#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ChannelLaunch.h"
std::auto_ptr<M_ChannelLaunch> M_ChannelLaunch::msSingleton(nullptr);

int M_ChannelLaunch::GetCount()
{
	return (int)mMapData.size();
}

const M_ChannelLaunchData* M_ChannelLaunch::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ChannelLaunchData>& M_ChannelLaunch::GetMapData()
{
	return mMapData;
}

void M_ChannelLaunch::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ChannelLaunch.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ChannelLaunchData data;
		data.mID = element->IntAttribute("ID");
		data.mChannel = element->IntAttribute("Channel");
		data.mLevel = element->IntAttribute("Level");
		data.mName = element->Attribute("Name");
		data.mType = element->IntAttribute("Type");
		data.mReward1 = element->IntAttribute("Reward1");
		data.mReward2 = element->FloatAttribute("Reward2");
		data.mRankingList = element->IntAttribute("RankingList");
		data.mQuota = element->IntAttribute("Quota");
		data.mLeaderboardRewards = element->IntAttribute("LeaderboardRewards");
		data.mIssueNumber = element->IntAttribute("IssueNumber");
		data.mPlayerType = element->IntAttribute("PlayerType");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ChannelLaunch Loaded. Load Data:%u", mMapData.size());
}

void M_ChannelLaunch::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ChannelLaunch");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ChannelLaunch");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ChannelLaunchData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Channel", data.mChannel);
		LuaCfgHelper::readInt(L, "Level", data.mLevel);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "Reward1", data.mReward1);
		LuaCfgHelper::readFloat(L, "Reward2", data.mReward2);
		LuaCfgHelper::readInt(L, "RankingList", data.mRankingList);
		LuaCfgHelper::readInt(L, "Quota", data.mQuota);
		LuaCfgHelper::readInt(L, "LeaderboardRewards", data.mLeaderboardRewards);
		LuaCfgHelper::readInt(L, "IssueNumber", data.mIssueNumber);
		LuaCfgHelper::readInt(L, "PlayerType", data.mPlayerType);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ChannelLaunch Loaded. Load Data:%u", mMapData.size());
}

void M_ChannelLaunch::Reload()
{
	mMapData.clear();
	Load();
}

M_ChannelLaunch* M_ChannelLaunch::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ChannelLaunch());
	}
	return msSingleton.get();
}

void M_ChannelLaunch::Release()
{
	msSingleton.reset(nullptr);
}
